/* Audio.c generated by valac 0.56.8, the Vala compiler
 * generated from Audio.vala, do not modify */

/* -*- Mode: vala; indent-tabs-mode: nil; tab-width: 4 -*-*/
/*-
 * Copyright (c) 2015-2018 elementary LLC. (https://elementary.io)
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 3 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this library; if not, write to the
 * Free Software Foundation, Inc., 51 Franklin Street - Fifth Floor,
 * Boston, MA 02110-1301, USA.
 *
 * Authored by: Felipe Escoto <felescoto95@hotmail.com>
 */

#include "accessibility.h"
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <gio/gio.h>
#include <glib-object.h>
#include <glib/gi18n-lib.h>
#include <granite.h>
#include <gtk/gtk.h>

enum  {
	ACCESSIBILITY_PANES_AUDIO_0_PROPERTY,
	ACCESSIBILITY_PANES_AUDIO_SCREENREADER_SHORTCUT_KEYS_PROPERTY,
	ACCESSIBILITY_PANES_AUDIO_NUM_PROPERTIES
};
static GParamSpec* accessibility_panes_audio_properties[ACCESSIBILITY_PANES_AUDIO_NUM_PROPERTIES];
#define _g_free0(var) (var = (g_free (var), NULL))
typedef struct _Block2Data Block2Data;
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))

struct _AccessibilityPanesAudioPrivate {
	gchar* _screenreader_shortcut_keys;
};

struct _Block2Data {
	int _ref_count_;
	AccessibilityPanesAudio* self;
	GtkLabel* shortcut_label;
};

static gint AccessibilityPanesAudio_private_offset;
static gpointer accessibility_panes_audio_parent_class = NULL;
static GSettings* accessibility_panes_audio_media_keys_settings;
static GSettings* accessibility_panes_audio_media_keys_settings = NULL;

static void _vala_array_add1 (gchar** * array,
                       gint* length,
                       gint* size,
                       gchar* value);
static GObject * accessibility_panes_audio_constructor (GType type,
                                                 guint n_construct_properties,
                                                 GObjectConstructParam * construct_properties);
static Block2Data* block2_data_ref (Block2Data* _data2_);
static void block2_data_unref (void * _userdata_);
static void _accessibility_panes_audio___lambda4_ (Block2Data* _data2_);
static void __accessibility_panes_audio___lambda4__g_settings_changed (GSettings* _sender,
                                                                const gchar* key,
                                                                gpointer self);
static void accessibility_panes_audio_finalize (GObject * obj);
static GType accessibility_panes_audio_get_type_once (void);
static void _vala_accessibility_panes_audio_get_property (GObject * object,
                                                   guint property_id,
                                                   GValue * value,
                                                   GParamSpec * pspec);
static void _vala_array_destroy (gpointer array,
                          gssize array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gssize array_length,
                       GDestroyNotify destroy_func);
static gssize _vala_array_length (gpointer array);

static inline gpointer
accessibility_panes_audio_get_instance_private (AccessibilityPanesAudio* self)
{
	return G_STRUCT_MEMBER_P (self, AccessibilityPanesAudio_private_offset);
}

AccessibilityPanesAudio*
accessibility_panes_audio_construct (GType object_type)
{
	AccessibilityPanesAudio * self = NULL;
	self = (AccessibilityPanesAudio*) g_object_new (object_type, "label-string", _ ("Audio"), "icon-name", "preferences-desktop-sound", NULL);
	return self;
}

AccessibilityPanesAudio*
accessibility_panes_audio_new (void)
{
	return accessibility_panes_audio_construct (ACCESSIBILITY_PANES_TYPE_AUDIO);
}

static void
_vala_array_add1 (gchar** * array,
                  gint* length,
                  gint* size,
                  gchar* value)
{
	if ((*length) == (*size)) {
		*size = (*size) ? (2 * (*size)) : 4;
		*array = g_renew (gchar*, *array, (*size) + 1);
	}
	(*array)[(*length)++] = value;
	(*array)[*length] = NULL;
}

static gchar*
_vala_g_strjoinv (const gchar* separator,
                  gchar** str_array,
                  gint str_array_length1)
{
	gboolean _tmp0_ = FALSE;
	gchar* result;
	if (separator == NULL) {
		separator = "";
	}
	if (str_array != NULL) {
		gboolean _tmp1_ = FALSE;
		if (str_array_length1 > 0) {
			_tmp1_ = TRUE;
		} else {
			gboolean _tmp2_ = FALSE;
			if (str_array_length1 == -1) {
				const gchar* _tmp3_;
				_tmp3_ = str_array[0];
				_tmp2_ = _tmp3_ != NULL;
			} else {
				_tmp2_ = FALSE;
			}
			_tmp1_ = _tmp2_;
		}
		_tmp0_ = _tmp1_;
	} else {
		_tmp0_ = FALSE;
	}
	if (_tmp0_) {
		gint i = 0;
		gsize len = 0UL;
		gint _tmp16_;
		gint _tmp17_;
		const gchar* res = NULL;
		void* _tmp18_;
		const gchar* _tmp19_ = NULL;
		const gchar* _tmp20_;
		void* ptr = NULL;
		const gchar* _tmp22_;
		void* _tmp23_;
		const gchar* _tmp33_;
		len = (gsize) 1;
		{
			gboolean _tmp4_ = FALSE;
			i = 0;
			_tmp4_ = TRUE;
			while (TRUE) {
				gboolean _tmp6_ = FALSE;
				gboolean _tmp7_ = FALSE;
				gint _tmp10_ = 0;
				const gchar* _tmp11_;
				if (!_tmp4_) {
					gint _tmp5_;
					_tmp5_ = i;
					i = _tmp5_ + 1;
				}
				_tmp4_ = FALSE;
				if (str_array_length1 != -1) {
					_tmp7_ = i < str_array_length1;
				} else {
					_tmp7_ = FALSE;
				}
				if (_tmp7_) {
					_tmp6_ = TRUE;
				} else {
					gboolean _tmp8_ = FALSE;
					if (str_array_length1 == -1) {
						const gchar* _tmp9_;
						_tmp9_ = str_array[i];
						_tmp8_ = _tmp9_ != NULL;
					} else {
						_tmp8_ = FALSE;
					}
					_tmp6_ = _tmp8_;
				}
				if (!_tmp6_) {
					break;
				}
				_tmp11_ = str_array[i];
				if (_tmp11_ != NULL) {
					const gchar* _tmp12_;
					gint _tmp13_;
					gint _tmp14_;
					_tmp12_ = str_array[i];
					_tmp13_ = strlen ((const gchar*) _tmp12_);
					_tmp14_ = _tmp13_;
					_tmp10_ = _tmp14_;
				} else {
					_tmp10_ = 0;
				}
				len += (gsize) _tmp10_;
			}
		}
		if (i == 0) {
			gchar* _tmp15_;
			_tmp15_ = g_strdup ("");
			result = _tmp15_;
			return result;
		}
		str_array_length1 = i;
		_tmp16_ = strlen ((const gchar*) separator);
		_tmp17_ = _tmp16_;
		len += (gsize) (_tmp17_ * (i - 1));
		_tmp18_ = g_malloc (len);
		res = _tmp18_;
		_tmp20_ = str_array[0];
		if (_tmp20_ != NULL) {
			const gchar* _tmp21_;
			_tmp21_ = str_array[0];
			_tmp19_ = (const gchar*) _tmp21_;
		} else {
			_tmp19_ = "";
		}
		_tmp22_ = res;
		_tmp23_ = g_stpcpy ((void*) _tmp22_, _tmp19_);
		ptr = _tmp23_;
		{
			gboolean _tmp24_ = FALSE;
			i = 1;
			_tmp24_ = TRUE;
			while (TRUE) {
				void* _tmp26_;
				void* _tmp27_;
				const gchar* _tmp28_ = NULL;
				const gchar* _tmp29_;
				void* _tmp31_;
				void* _tmp32_;
				if (!_tmp24_) {
					gint _tmp25_;
					_tmp25_ = i;
					i = _tmp25_ + 1;
				}
				_tmp24_ = FALSE;
				if (!(i < str_array_length1)) {
					break;
				}
				_tmp26_ = ptr;
				_tmp27_ = g_stpcpy (_tmp26_, (const gchar*) separator);
				ptr = _tmp27_;
				_tmp29_ = str_array[i];
				if (_tmp29_ != NULL) {
					const gchar* _tmp30_;
					_tmp30_ = str_array[i];
					_tmp28_ = (const gchar*) _tmp30_;
				} else {
					_tmp28_ = "";
				}
				_tmp31_ = ptr;
				_tmp32_ = g_stpcpy (_tmp31_, _tmp28_);
				ptr = _tmp32_;
			}
		}
		_tmp33_ = res;
		res = NULL;
		result = (gchar*) _tmp33_;
		return result;
	} else {
		gchar* _tmp34_;
		_tmp34_ = g_strdup ("");
		result = _tmp34_;
		return result;
	}
}

const gchar*
accessibility_panes_audio_get_screenreader_shortcut_keys (AccessibilityPanesAudio* self)
{
	const gchar* result;
	gchar** granite_accel_strings = NULL;
	gint granite_accel_strings_length1;
	gint _granite_accel_strings_size_;
	GSettings* _tmp0_;
	gchar** _tmp1_;
	gchar** _tmp2_;
	gchar** _tmp6_;
	gint _tmp6__length1;
	gchar* _tmp7_;
	const gchar* _tmp8_;
	g_return_val_if_fail (self != NULL, NULL);
	granite_accel_strings = NULL;
	granite_accel_strings_length1 = 0;
	_granite_accel_strings_size_ = granite_accel_strings_length1;
	_tmp0_ = accessibility_panes_audio_media_keys_settings;
	_tmp2_ = _tmp1_ = g_settings_get_strv (_tmp0_, "screenreader");
	{
		gchar** key_collection = NULL;
		gint key_collection_length1 = 0;
		gint _key_collection_size_ = 0;
		gint key_it = 0;
		key_collection = _tmp2_;
		key_collection_length1 = _vala_array_length (_tmp1_);
		for (key_it = 0; key_it < key_collection_length1; key_it = key_it + 1) {
			gchar* _tmp3_;
			gchar* key = NULL;
			_tmp3_ = g_strdup (key_collection[key_it]);
			key = _tmp3_;
			{
				const gchar* _tmp4_;
				gchar* _tmp5_;
				_tmp4_ = key;
				_tmp5_ = granite_accel_to_string (_tmp4_);
				_vala_array_add1 (&granite_accel_strings, &granite_accel_strings_length1, &_granite_accel_strings_size_, _tmp5_);
				_g_free0 (key);
			}
		}
		key_collection = (_vala_array_free (key_collection, key_collection_length1, (GDestroyNotify) g_free), NULL);
	}
	_tmp6_ = granite_accel_strings;
	_tmp6__length1 = granite_accel_strings_length1;
	_tmp7_ = _vala_g_strjoinv (_ (", "), _tmp6_, (gint) _tmp6__length1);
	_g_free0 (self->priv->_screenreader_shortcut_keys);
	self->priv->_screenreader_shortcut_keys = _tmp7_;
	_tmp8_ = self->priv->_screenreader_shortcut_keys;
	result = _tmp8_;
	granite_accel_strings = (_vala_array_free (granite_accel_strings, granite_accel_strings_length1, (GDestroyNotify) g_free), NULL);
	return result;
}

static Block2Data*
block2_data_ref (Block2Data* _data2_)
{
	g_atomic_int_inc (&_data2_->_ref_count_);
	return _data2_;
}

static void
block2_data_unref (void * _userdata_)
{
	Block2Data* _data2_;
	_data2_ = (Block2Data*) _userdata_;
	if (g_atomic_int_dec_and_test (&_data2_->_ref_count_)) {
		AccessibilityPanesAudio* self;
		self = _data2_->self;
		_g_object_unref0 (_data2_->shortcut_label);
		_g_object_unref0 (self);
		g_slice_free (Block2Data, _data2_);
	}
}

static void
_accessibility_panes_audio___lambda4_ (Block2Data* _data2_)
{
	AccessibilityPanesAudio* self;
	GtkLabel* _tmp0_;
	const gchar* _tmp1_;
	const gchar* _tmp2_;
	self = _data2_->self;
	_tmp0_ = _data2_->shortcut_label;
	_tmp1_ = accessibility_panes_audio_get_screenreader_shortcut_keys (self);
	_tmp2_ = _tmp1_;
	gtk_label_set_label (_tmp0_, _tmp2_);
}

static void
__accessibility_panes_audio___lambda4__g_settings_changed (GSettings* _sender,
                                                           const gchar* key,
                                                           gpointer self)
{
	_accessibility_panes_audio___lambda4_ (self);
}

static GObject *
accessibility_panes_audio_constructor (GType type,
                                       guint n_construct_properties,
                                       GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	AccessibilityPanesAudio * self;
	Block2Data* _data2_;
	GraniteHeaderLabel* reader_label = NULL;
	GraniteHeaderLabel* _tmp0_;
	AccessibilityWidgetsSettingsBox* reader_box = NULL;
	AccessibilityWidgetsSettingsBox* _tmp1_;
	GtkSwitch* read_items = NULL;
	AccessibilityWidgetsSettingsBox* _tmp2_;
	GtkSwitch* _tmp3_;
	const gchar* _tmp4_;
	const gchar* _tmp5_;
	GtkLabel* _tmp6_;
	AccessibilityWidgetsSettingsBox* _tmp7_;
	GtkLabel* _tmp8_;
	AccessibilityWidgetsLinkLabel* audio_settings = NULL;
	AccessibilityWidgetsLinkLabel* _tmp9_;
	AccessibilityWidgetsLinkLabel* _tmp10_;
	GtkGrid* _tmp11_;
	GtkGrid* _tmp12_;
	GraniteHeaderLabel* _tmp13_;
	GtkGrid* _tmp14_;
	GtkGrid* _tmp15_;
	AccessibilityWidgetsSettingsBox* _tmp16_;
	GtkGrid* _tmp17_;
	GtkGrid* _tmp18_;
	AccessibilityWidgetsLinkLabel* _tmp19_;
	GtkGrid* _tmp20_;
	GtkGrid* _tmp21_;
	GSettings* _tmp22_;
	GtkSwitch* _tmp23_;
	GSettings* _tmp24_;
	parent_class = G_OBJECT_CLASS (accessibility_panes_audio_parent_class);
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, ACCESSIBILITY_PANES_TYPE_AUDIO, AccessibilityPanesAudio);
	_data2_ = g_slice_new0 (Block2Data);
	_data2_->_ref_count_ = 1;
	_data2_->self = g_object_ref (self);
	_tmp0_ = granite_header_label_new (_ ("Screen Reader"));
	g_object_ref_sink (_tmp0_);
	reader_label = _tmp0_;
	_tmp1_ = accessibility_widgets_settings_box_new ();
	g_object_ref_sink (_tmp1_);
	reader_box = _tmp1_;
	_tmp2_ = reader_box;
	_tmp3_ = accessibility_widgets_settings_box_add_switch (_tmp2_, _ ("Provide audio descriptions for items on the screen"));
	read_items = _tmp3_;
	_tmp4_ = accessibility_panes_audio_get_screenreader_shortcut_keys (self);
	_tmp5_ = _tmp4_;
	_tmp6_ = (GtkLabel*) gtk_label_new (_tmp5_);
	g_object_ref_sink (_tmp6_);
	_data2_->shortcut_label = _tmp6_;
	_tmp7_ = reader_box;
	_tmp8_ = _data2_->shortcut_label;
	accessibility_widgets_settings_box_add_widget (_tmp7_, _ ("Keyboard shortcut"), (GtkWidget*) _tmp8_);
	_tmp9_ = accessibility_widgets_link_label_new (_ ("Sound settings…"), "settings://sound");
	g_object_ref_sink (_tmp9_);
	audio_settings = _tmp9_;
	_tmp10_ = audio_settings;
	gtk_widget_set_vexpand ((GtkWidget*) _tmp10_, TRUE);
	_tmp11_ = accessibility_categories_pane_get_grid ((AccessibilityCategoriesPane*) self);
	_tmp12_ = _tmp11_;
	_tmp13_ = reader_label;
	gtk_container_add ((GtkContainer*) _tmp12_, (GtkWidget*) _tmp13_);
	_tmp14_ = accessibility_categories_pane_get_grid ((AccessibilityCategoriesPane*) self);
	_tmp15_ = _tmp14_;
	_tmp16_ = reader_box;
	gtk_container_add ((GtkContainer*) _tmp15_, (GtkWidget*) _tmp16_);
	_tmp17_ = accessibility_categories_pane_get_grid ((AccessibilityCategoriesPane*) self);
	_tmp18_ = _tmp17_;
	_tmp19_ = audio_settings;
	gtk_container_add ((GtkContainer*) _tmp18_, (GtkWidget*) _tmp19_);
	_tmp20_ = accessibility_categories_pane_get_grid ((AccessibilityCategoriesPane*) self);
	_tmp21_ = _tmp20_;
	gtk_widget_show_all ((GtkWidget*) _tmp21_);
	_tmp22_ = accessibility_plug_applications_settings;
	_tmp23_ = read_items;
	g_settings_bind (_tmp22_, "screen-reader-enabled", (GObject*) _tmp23_, "active", G_SETTINGS_BIND_DEFAULT);
	_tmp24_ = accessibility_panes_audio_media_keys_settings;
	g_signal_connect_data (_tmp24_, "changed", (GCallback) __accessibility_panes_audio___lambda4__g_settings_changed, block2_data_ref (_data2_), (GClosureNotify) block2_data_unref, 0);
	_g_object_unref0 (audio_settings);
	_g_object_unref0 (read_items);
	_g_object_unref0 (reader_box);
	_g_object_unref0 (reader_label);
	block2_data_unref (_data2_);
	_data2_ = NULL;
	return obj;
}

static void
accessibility_panes_audio_class_init (AccessibilityPanesAudioClass * klass,
                                      gpointer klass_data)
{
	GSettings* _tmp0_;
	accessibility_panes_audio_parent_class = g_type_class_peek_parent (klass);
	g_type_class_adjust_private_offset (klass, &AccessibilityPanesAudio_private_offset);
	G_OBJECT_CLASS (klass)->get_property = _vala_accessibility_panes_audio_get_property;
	G_OBJECT_CLASS (klass)->constructor = accessibility_panes_audio_constructor;
	G_OBJECT_CLASS (klass)->finalize = accessibility_panes_audio_finalize;
	g_object_class_install_property (G_OBJECT_CLASS (klass), ACCESSIBILITY_PANES_AUDIO_SCREENREADER_SHORTCUT_KEYS_PROPERTY, accessibility_panes_audio_properties[ACCESSIBILITY_PANES_AUDIO_SCREENREADER_SHORTCUT_KEYS_PROPERTY] = g_param_spec_string ("screenreader-shortcut-keys", "screenreader-shortcut-keys", "screenreader-shortcut-keys", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
	_tmp0_ = g_settings_new ("org.gnome.settings-daemon.plugins.media-keys");
	_g_object_unref0 (accessibility_panes_audio_media_keys_settings);
	accessibility_panes_audio_media_keys_settings = _tmp0_;
}

static void
accessibility_panes_audio_instance_init (AccessibilityPanesAudio * self,
                                         gpointer klass)
{
	gchar* _tmp0_;
	self->priv = accessibility_panes_audio_get_instance_private (self);
	_tmp0_ = g_strdup ("");
	self->priv->_screenreader_shortcut_keys = _tmp0_;
}

static void
accessibility_panes_audio_finalize (GObject * obj)
{
	AccessibilityPanesAudio * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, ACCESSIBILITY_PANES_TYPE_AUDIO, AccessibilityPanesAudio);
	_g_free0 (self->priv->_screenreader_shortcut_keys);
	G_OBJECT_CLASS (accessibility_panes_audio_parent_class)->finalize (obj);
}

static GType
accessibility_panes_audio_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (AccessibilityPanesAudioClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) accessibility_panes_audio_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (AccessibilityPanesAudio), 0, (GInstanceInitFunc) accessibility_panes_audio_instance_init, NULL };
	GType accessibility_panes_audio_type_id;
	accessibility_panes_audio_type_id = g_type_register_static (ACCESSIBILITY_CATEGORIES_TYPE_PANE, "AccessibilityPanesAudio", &g_define_type_info, 0);
	AccessibilityPanesAudio_private_offset = g_type_add_instance_private (accessibility_panes_audio_type_id, sizeof (AccessibilityPanesAudioPrivate));
	return accessibility_panes_audio_type_id;
}

GType
accessibility_panes_audio_get_type (void)
{
	static volatile gsize accessibility_panes_audio_type_id__once = 0;
	if (g_once_init_enter (&accessibility_panes_audio_type_id__once)) {
		GType accessibility_panes_audio_type_id;
		accessibility_panes_audio_type_id = accessibility_panes_audio_get_type_once ();
		g_once_init_leave (&accessibility_panes_audio_type_id__once, accessibility_panes_audio_type_id);
	}
	return accessibility_panes_audio_type_id__once;
}

static void
_vala_accessibility_panes_audio_get_property (GObject * object,
                                              guint property_id,
                                              GValue * value,
                                              GParamSpec * pspec)
{
	AccessibilityPanesAudio * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, ACCESSIBILITY_PANES_TYPE_AUDIO, AccessibilityPanesAudio);
	switch (property_id) {
		case ACCESSIBILITY_PANES_AUDIO_SCREENREADER_SHORTCUT_KEYS_PROPERTY:
		g_value_set_string (value, accessibility_panes_audio_get_screenreader_shortcut_keys (self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

static void
_vala_array_destroy (gpointer array,
                     gssize array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		gssize i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gssize array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

static gssize
_vala_array_length (gpointer array)
{
	gssize length;
	length = 0;
	if (array) {
		while (((gpointer*) array)[length]) {
			length++;
		}
	}
	return length;
}

