/* Keyboard.c generated by valac 0.56.8, the Vala compiler
 * generated from Keyboard.vala, do not modify */

/* -*- Mode: vala; indent-tabs-mode: nil; tab-width: 4 -*-*/
/*-
 * Copyright (c) 2015-2018 elementary LLC. (https://elementary.io)
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 3 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this library; if not, write to the
 * Free Software Foundation, Inc., 51 Franklin Street - Fifth Floor,
 * Boston, MA 02110-1301, USA.
 *
 * Authored by: Felipe Escoto <felescoto95@hotmail.com>
 */

#include "accessibility.h"
#include <glib-object.h>
#include <glib.h>
#include <glib/gi18n-lib.h>
#include <granite.h>
#include <gtk/gtk.h>
#include <gio/gio.h>

enum  {
	ACCESSIBILITY_PANES_KEYBOARD_0_PROPERTY,
	ACCESSIBILITY_PANES_KEYBOARD_NUM_PROPERTIES
};
static GParamSpec* accessibility_panes_keyboard_properties[ACCESSIBILITY_PANES_KEYBOARD_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))

static gpointer accessibility_panes_keyboard_parent_class = NULL;

static GObject * accessibility_panes_keyboard_constructor (GType type,
                                                    guint n_construct_properties,
                                                    GObjectConstructParam * construct_properties);
static GType accessibility_panes_keyboard_get_type_once (void);

AccessibilityPanesKeyboard*
accessibility_panes_keyboard_construct (GType object_type)
{
	AccessibilityPanesKeyboard * self = NULL;
	self = (AccessibilityPanesKeyboard*) g_object_new (object_type, "label-string", _ ("Keyboard"), "icon-name", "preferences-desktop-keyboard", NULL);
	return self;
}

AccessibilityPanesKeyboard*
accessibility_panes_keyboard_new (void)
{
	return accessibility_panes_keyboard_construct (ACCESSIBILITY_PANES_TYPE_KEYBOARD);
}

static GObject *
accessibility_panes_keyboard_constructor (GType type,
                                          guint n_construct_properties,
                                          GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	AccessibilityPanesKeyboard * self;
	GraniteHeaderLabel* lock_label = NULL;
	GraniteHeaderLabel* _tmp0_;
	GraniteHeaderLabel* modifier_label = NULL;
	GraniteHeaderLabel* _tmp1_;
	AccessibilityWidgetsLinkLabel* kb_settings_label = NULL;
	AccessibilityWidgetsLinkLabel* _tmp2_;
	AccessibilityWidgetsLinkLabel* _tmp3_;
	AccessibilityWidgetsSettingsBox* lock_box = NULL;
	AccessibilityWidgetsSettingsBox* _tmp4_;
	GtkSwitch* lk_beep = NULL;
	AccessibilityWidgetsSettingsBox* _tmp5_;
	GtkSwitch* _tmp6_;
	AccessibilityWidgetsSettingsBox* modifier_box = NULL;
	AccessibilityWidgetsSettingsBox* _tmp7_;
	GtkSwitch* mk_enable = NULL;
	AccessibilityWidgetsSettingsBox* _tmp8_;
	GtkSwitch* _tmp9_;
	GtkSwitch* mk_beep = NULL;
	AccessibilityWidgetsSettingsBox* _tmp10_;
	GtkSwitch* _tmp11_;
	GtkGrid* _tmp12_;
	GtkGrid* _tmp13_;
	GraniteHeaderLabel* _tmp14_;
	GtkGrid* _tmp15_;
	GtkGrid* _tmp16_;
	AccessibilityWidgetsSettingsBox* _tmp17_;
	GtkGrid* _tmp18_;
	GtkGrid* _tmp19_;
	GraniteHeaderLabel* _tmp20_;
	GtkGrid* _tmp21_;
	GtkGrid* _tmp22_;
	AccessibilityWidgetsSettingsBox* _tmp23_;
	GtkGrid* _tmp24_;
	GtkGrid* _tmp25_;
	AccessibilityWidgetsLinkLabel* _tmp26_;
	GtkGrid* _tmp27_;
	GtkGrid* _tmp28_;
	GSettings* _tmp29_;
	GtkSwitch* _tmp30_;
	GSettings* _tmp31_;
	GtkSwitch* _tmp32_;
	GSettings* _tmp33_;
	GtkSwitch* _tmp34_;
	GSettings* _tmp35_;
	GtkSwitch* _tmp36_;
	parent_class = G_OBJECT_CLASS (accessibility_panes_keyboard_parent_class);
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, ACCESSIBILITY_PANES_TYPE_KEYBOARD, AccessibilityPanesKeyboard);
	_tmp0_ = granite_header_label_new (_ ("Lock Keys"));
	g_object_ref_sink (_tmp0_);
	lock_label = _tmp0_;
	_tmp1_ = granite_header_label_new (_ ("Modifier Keys"));
	g_object_ref_sink (_tmp1_);
	modifier_label = _tmp1_;
	_tmp2_ = accessibility_widgets_link_label_new (_ ("Keyboard settings…"), "settings://input/keyboard/behavior");
	g_object_ref_sink (_tmp2_);
	kb_settings_label = _tmp2_;
	_tmp3_ = kb_settings_label;
	gtk_widget_set_vexpand ((GtkWidget*) _tmp3_, TRUE);
	_tmp4_ = accessibility_widgets_settings_box_new ();
	g_object_ref_sink (_tmp4_);
	lock_box = _tmp4_;
	_tmp5_ = lock_box;
	_tmp6_ = accessibility_widgets_settings_box_add_switch (_tmp5_, _ ("Beep when a lock key is pressed"));
	lk_beep = _tmp6_;
	_tmp7_ = accessibility_widgets_settings_box_new ();
	g_object_ref_sink (_tmp7_);
	modifier_box = _tmp7_;
	_tmp8_ = modifier_box;
	_tmp9_ = accessibility_widgets_settings_box_add_switch (_tmp8_, _ ("Use modifier keys in sequence (sticky keys)"));
	mk_enable = _tmp9_;
	_tmp10_ = modifier_box;
	_tmp11_ = accessibility_widgets_settings_box_add_switch (_tmp10_, _ ("Beep when a modifier key is pressed"));
	mk_beep = _tmp11_;
	_tmp12_ = accessibility_categories_pane_get_grid ((AccessibilityCategoriesPane*) self);
	_tmp13_ = _tmp12_;
	_tmp14_ = lock_label;
	gtk_container_add ((GtkContainer*) _tmp13_, (GtkWidget*) _tmp14_);
	_tmp15_ = accessibility_categories_pane_get_grid ((AccessibilityCategoriesPane*) self);
	_tmp16_ = _tmp15_;
	_tmp17_ = lock_box;
	gtk_container_add ((GtkContainer*) _tmp16_, (GtkWidget*) _tmp17_);
	_tmp18_ = accessibility_categories_pane_get_grid ((AccessibilityCategoriesPane*) self);
	_tmp19_ = _tmp18_;
	_tmp20_ = modifier_label;
	gtk_container_add ((GtkContainer*) _tmp19_, (GtkWidget*) _tmp20_);
	_tmp21_ = accessibility_categories_pane_get_grid ((AccessibilityCategoriesPane*) self);
	_tmp22_ = _tmp21_;
	_tmp23_ = modifier_box;
	gtk_container_add ((GtkContainer*) _tmp22_, (GtkWidget*) _tmp23_);
	_tmp24_ = accessibility_categories_pane_get_grid ((AccessibilityCategoriesPane*) self);
	_tmp25_ = _tmp24_;
	_tmp26_ = kb_settings_label;
	gtk_container_add ((GtkContainer*) _tmp25_, (GtkWidget*) _tmp26_);
	_tmp27_ = accessibility_categories_pane_get_grid ((AccessibilityCategoriesPane*) self);
	_tmp28_ = _tmp27_;
	gtk_widget_show_all ((GtkWidget*) _tmp28_);
	_tmp29_ = accessibility_plug_keyboard_settings;
	_tmp30_ = lk_beep;
	g_settings_bind (_tmp29_, "togglekeys-enable", (GObject*) _tmp30_, "active", G_SETTINGS_BIND_DEFAULT);
	_tmp31_ = accessibility_plug_keyboard_settings;
	_tmp32_ = mk_enable;
	g_settings_bind (_tmp31_, "stickykeys-enable", (GObject*) _tmp32_, "active", G_SETTINGS_BIND_DEFAULT);
	_tmp33_ = accessibility_plug_keyboard_settings;
	_tmp34_ = mk_beep;
	g_settings_bind (_tmp33_, "stickykeys-modifier-beep", (GObject*) _tmp34_, "active", G_SETTINGS_BIND_DEFAULT);
	_tmp35_ = accessibility_plug_keyboard_settings;
	_tmp36_ = mk_beep;
	g_settings_bind (_tmp35_, "stickykeys-enable", (GObject*) _tmp36_, "sensitive", G_SETTINGS_BIND_GET);
	_g_object_unref0 (mk_beep);
	_g_object_unref0 (mk_enable);
	_g_object_unref0 (modifier_box);
	_g_object_unref0 (lk_beep);
	_g_object_unref0 (lock_box);
	_g_object_unref0 (kb_settings_label);
	_g_object_unref0 (modifier_label);
	_g_object_unref0 (lock_label);
	return obj;
}

static void
accessibility_panes_keyboard_class_init (AccessibilityPanesKeyboardClass * klass,
                                         gpointer klass_data)
{
	accessibility_panes_keyboard_parent_class = g_type_class_peek_parent (klass);
	G_OBJECT_CLASS (klass)->constructor = accessibility_panes_keyboard_constructor;
}

static void
accessibility_panes_keyboard_instance_init (AccessibilityPanesKeyboard * self,
                                            gpointer klass)
{
}

static GType
accessibility_panes_keyboard_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (AccessibilityPanesKeyboardClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) accessibility_panes_keyboard_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (AccessibilityPanesKeyboard), 0, (GInstanceInitFunc) accessibility_panes_keyboard_instance_init, NULL };
	GType accessibility_panes_keyboard_type_id;
	accessibility_panes_keyboard_type_id = g_type_register_static (ACCESSIBILITY_CATEGORIES_TYPE_PANE, "AccessibilityPanesKeyboard", &g_define_type_info, 0);
	return accessibility_panes_keyboard_type_id;
}

GType
accessibility_panes_keyboard_get_type (void)
{
	static volatile gsize accessibility_panes_keyboard_type_id__once = 0;
	if (g_once_init_enter (&accessibility_panes_keyboard_type_id__once)) {
		GType accessibility_panes_keyboard_type_id;
		accessibility_panes_keyboard_type_id = accessibility_panes_keyboard_get_type_once ();
		g_once_init_leave (&accessibility_panes_keyboard_type_id__once, accessibility_panes_keyboard_type_id);
	}
	return accessibility_panes_keyboard_type_id__once;
}

