/* Plug.c generated by valac 0.56.8, the Vala compiler
 * generated from Plug.vala, do not modify */

/*-
 * Copyright 2015–2021 elementary, Inc (https://elementary.io)
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 3 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this library; if not, write to the
 * Free Software Foundation, Inc., 51 Franklin Street - Fifth Floor,
 * Boston, MA 02110-1301, USA.
 *
 * Authored by: Corentin Noël <corentin@elementary.io>
 */

#include "accessibility.h"
#include <gtk/gtk.h>
#include <switchboard.h>
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <gio/gio.h>
#include <gee.h>
#include <glib-object.h>
#include <glib/gi18n-lib.h>
#include <float.h>
#include <math.h>
#include <granite.h>
#include <gmodule.h>

enum  {
	ACCESSIBILITY_PLUG_0_PROPERTY,
	ACCESSIBILITY_PLUG_NUM_PROPERTIES
};
static GParamSpec* accessibility_plug_properties[ACCESSIBILITY_PLUG_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
typedef struct _AccessibilityPlugSearchData AccessibilityPlugSearchData;

struct _AccessibilityPlugPrivate {
	GtkGrid* grid;
	AccessibilityCategories* categories;
};

struct _AccessibilityPlugSearchData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	AccessibilityPlug* self;
	gchar* search;
	GeeTreeMap* result;
	GeeTreeMap* search_results;
	GCompareFunc _tmp0_;
	GEqualFunc _tmp1_;
	GeeTreeMap* _tmp2_;
	const gchar* _tmp3_;
	const gchar* _tmp4_;
	gchar* _tmp5_;
	gchar* _tmp6_;
	const gchar* _tmp7_;
	const gchar* _tmp8_;
	gchar* _tmp9_;
	gchar* _tmp10_;
	const gchar* _tmp11_;
	const gchar* _tmp12_;
	gchar* _tmp13_;
	gchar* _tmp14_;
	const gchar* _tmp15_;
	const gchar* _tmp16_;
	gchar* _tmp17_;
	gchar* _tmp18_;
	const gchar* _tmp19_;
	const gchar* _tmp20_;
	gchar* _tmp21_;
	gchar* _tmp22_;
	const gchar* _tmp23_;
	const gchar* _tmp24_;
	gchar* _tmp25_;
	gchar* _tmp26_;
	const gchar* _tmp27_;
	const gchar* _tmp28_;
	gchar* _tmp29_;
	gchar* _tmp30_;
	const gchar* _tmp31_;
	const gchar* _tmp32_;
	gchar* _tmp33_;
	gchar* _tmp34_;
	const gchar* _tmp35_;
	const gchar* _tmp36_;
	gchar* _tmp37_;
	gchar* _tmp38_;
	const gchar* _tmp39_;
	const gchar* _tmp40_;
	gchar* _tmp41_;
	gchar* _tmp42_;
	const gchar* _tmp43_;
	const gchar* _tmp44_;
	gchar* _tmp45_;
	gchar* _tmp46_;
	const gchar* _tmp47_;
	const gchar* _tmp48_;
	gchar* _tmp49_;
	gchar* _tmp50_;
	const gchar* _tmp51_;
	const gchar* _tmp52_;
	gchar* _tmp53_;
	gchar* _tmp54_;
	const gchar* _tmp55_;
	const gchar* _tmp56_;
	gchar* _tmp57_;
	gchar* _tmp58_;
	const gchar* _tmp59_;
	const gchar* _tmp60_;
	gchar* _tmp61_;
	gchar* _tmp62_;
	const gchar* _tmp63_;
	const gchar* _tmp64_;
	gchar* _tmp65_;
	gchar* _tmp66_;
	const gchar* _tmp67_;
	const gchar* _tmp68_;
	gchar* _tmp69_;
	gchar* _tmp70_;
	const gchar* _tmp71_;
	const gchar* _tmp72_;
	gchar* _tmp73_;
	gchar* _tmp74_;
	const gchar* _tmp75_;
	const gchar* _tmp76_;
	gchar* _tmp77_;
	gchar* _tmp78_;
	const gchar* _tmp79_;
	const gchar* _tmp80_;
	gchar* _tmp81_;
	gchar* _tmp82_;
	const gchar* _tmp83_;
	const gchar* _tmp84_;
	gchar* _tmp85_;
	gchar* _tmp86_;
	const gchar* _tmp87_;
	const gchar* _tmp88_;
	gchar* _tmp89_;
	gchar* _tmp90_;
	const gchar* _tmp91_;
	const gchar* _tmp92_;
	gchar* _tmp93_;
	gchar* _tmp94_;
	const gchar* _tmp95_;
	const gchar* _tmp96_;
	gchar* _tmp97_;
	gchar* _tmp98_;
};

static gint AccessibilityPlug_private_offset;
static gpointer accessibility_plug_parent_class = NULL;
GSettings* accessibility_plug_applications_settings = NULL;
GSettings* accessibility_plug_keyboard_settings = NULL;

static GtkWidget* accessibility_plug_real_get_widget (SwitchboardPlug* base);
static void accessibility_plug_real_shown (SwitchboardPlug* base);
static void accessibility_plug_real_hidden (SwitchboardPlug* base);
static void accessibility_plug_real_search_callback (SwitchboardPlug* base,
                                              const gchar* location);
static void accessibility_plug_real_search_data_free (gpointer _data);
static void accessibility_plug_real_search (SwitchboardPlug* base,
                                     const gchar* search,
                                     GAsyncReadyCallback _callback_,
                                     gpointer _user_data_);
static gboolean accessibility_plug_real_search_co (AccessibilityPlugSearchData* _data_);
static void accessibility_plug_finalize (GObject * obj);
static GType accessibility_plug_get_type_once (void);

static inline gpointer
accessibility_plug_get_instance_private (AccessibilityPlug* self)
{
	return G_STRUCT_MEMBER_P (self, AccessibilityPlug_private_offset);
}

AccessibilityPlug*
accessibility_plug_construct (GType object_type)
{
	AccessibilityPlug * self = NULL;
	GeeTreeMap* settings = NULL;
	GeeTreeMap* _tmp0_;
	_tmp0_ = gee_tree_map_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, NULL, NULL, NULL, NULL, NULL, NULL);
	settings = _tmp0_;
	gee_abstract_map_set ((GeeAbstractMap*) settings, "universal-access", NULL);
	self = (AccessibilityPlug*) g_object_new (object_type, "category", SWITCHBOARD_PLUG_CATEGORY_SYSTEM, "code-name", "io.elementary.switchboard.a11y", "display-name", _ ("Universal Access"), "description", _ ("Configure accessibility features"), "icon", "preferences-desktop-accessibility", "supported-settings", settings, NULL);
	_g_object_unref0 (settings);
	return self;
}

AccessibilityPlug*
accessibility_plug_new (void)
{
	return accessibility_plug_construct (ACCESSIBILITY_TYPE_PLUG);
}

static gpointer
_g_object_ref0 (gpointer self)
{
	return self ? g_object_ref (self) : NULL;
}

static GtkWidget*
accessibility_plug_real_get_widget (SwitchboardPlug* base)
{
	AccessibilityPlug * self;
	GtkGrid* _tmp0_;
	GtkGrid* _tmp47_;
	GtkWidget* _tmp48_;
	GtkWidget* result;
	self = (AccessibilityPlug*) base;
	_tmp0_ = self->priv->grid;
	if (_tmp0_ == NULL) {
		gchar* info_title = NULL;
		gchar* _tmp1_;
		gchar* info_details = NULL;
		gchar* _tmp2_;
		GtkLabel* info_label = NULL;
		const gchar* _tmp3_;
		const gchar* _tmp4_;
		gchar* _tmp5_;
		gchar* _tmp6_;
		GtkLabel* _tmp7_ = NULL;
		GtkLabel* _tmp8_;
		GtkInfoBar* infobar = NULL;
		GtkInfoBar* _tmp9_;
		GtkBox* infobar_box = NULL;
		GtkInfoBar* _tmp10_;
		GtkContainer* _tmp11_;
		GtkBox* _tmp12_;
		GtkBox* _tmp13_;
		GtkLabel* _tmp14_;
		GtkStack* stack = NULL;
		GtkStack* _tmp15_;
		AccessibilityCategories* _tmp16_;
		AccessibilityCategories* _tmp17_;
		GtkStack* _tmp18_;
		GraniteHeaderLabel* indicator_label = NULL;
		GraniteHeaderLabel* _tmp19_ = NULL;
		GtkSwitch* indicator_switch = NULL;
		GtkSwitch* _tmp20_ = NULL;
		GtkActionBar* footer = NULL;
		GtkActionBar* _tmp21_;
		GtkActionBar* _tmp22_;
		GtkStyleContext* _tmp23_;
		GtkActionBar* _tmp24_;
		GraniteHeaderLabel* _tmp25_;
		GtkActionBar* _tmp26_;
		GtkSwitch* _tmp27_;
		GtkGrid* sidebar = NULL;
		GtkGrid* _tmp28_;
		GtkGrid* _tmp29_;
		AccessibilityCategories* _tmp30_;
		GtkGrid* _tmp31_;
		GtkActionBar* _tmp32_;
		GtkPaned* paned = NULL;
		GtkPaned* _tmp33_;
		GtkPaned* _tmp34_;
		GtkGrid* _tmp35_;
		GtkPaned* _tmp36_;
		GtkStack* _tmp37_;
		GtkGrid* _tmp38_ = NULL;
		GtkGrid* _tmp39_;
		GtkInfoBar* _tmp40_;
		GtkGrid* _tmp41_;
		GtkPaned* _tmp42_;
		GtkGrid* _tmp43_;
		GSettings* panel_settings = NULL;
		GSettings* _tmp44_;
		GSettings* _tmp45_;
		GtkSwitch* _tmp46_;
		_tmp1_ = g_strdup (_ ("More accessibility features can be found throughout System Settings."));
		info_title = _tmp1_;
		_tmp2_ = g_strdup (_ ("Check the relevant settings pages or search from the All Settings scre" \
"en."));
		info_details = _tmp2_;
		_tmp3_ = info_title;
		_tmp4_ = info_details;
		_tmp5_ = g_strdup_printf ("<b>%s</b> %s", _tmp3_, _tmp4_);
		_tmp6_ = _tmp5_;
		_tmp7_ = (GtkLabel*) gtk_label_new (_tmp6_);
		gtk_label_set_use_markup (_tmp7_, TRUE);
		g_object_set (_tmp7_, "wrap", TRUE, NULL);
		gtk_label_set_xalign (_tmp7_, (gfloat) 0);
		g_object_ref_sink (_tmp7_);
		_tmp8_ = _tmp7_;
		_g_free0 (_tmp6_);
		info_label = _tmp8_;
		_tmp9_ = (GtkInfoBar*) gtk_info_bar_new ();
		g_object_ref_sink (_tmp9_);
		infobar = _tmp9_;
		_tmp10_ = infobar;
		_tmp11_ = gtk_info_bar_get_content_area (_tmp10_);
		_tmp12_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp11_, gtk_box_get_type (), GtkBox));
		infobar_box = _tmp12_;
		_tmp13_ = infobar_box;
		_tmp14_ = info_label;
		gtk_box_pack_start (_tmp13_, (GtkWidget*) _tmp14_, TRUE, TRUE, (guint) 0);
		_tmp15_ = (GtkStack*) gtk_stack_new ();
		g_object_ref_sink (_tmp15_);
		stack = _tmp15_;
		_tmp16_ = accessibility_categories_new ();
		g_object_ref_sink (_tmp16_);
		_g_object_unref0 (self->priv->categories);
		self->priv->categories = _tmp16_;
		_tmp17_ = self->priv->categories;
		_tmp18_ = stack;
		accessibility_categories_set_stack (_tmp17_, _tmp18_);
		_tmp19_ = granite_header_label_new (_ ("Show in Panel"));
		gtk_widget_set_margin_start ((GtkWidget*) _tmp19_, 3);
		g_object_ref_sink (_tmp19_);
		indicator_label = _tmp19_;
		_tmp20_ = (GtkSwitch*) gtk_switch_new ();
		g_object_set ((GtkWidget*) _tmp20_, "margin", 6, NULL);
		gtk_widget_set_margin_end ((GtkWidget*) _tmp20_, 3);
		g_object_ref_sink (_tmp20_);
		indicator_switch = _tmp20_;
		_tmp21_ = (GtkActionBar*) gtk_action_bar_new ();
		g_object_ref_sink (_tmp21_);
		footer = _tmp21_;
		_tmp22_ = footer;
		_tmp23_ = gtk_widget_get_style_context ((GtkWidget*) _tmp22_);
		gtk_style_context_add_class (_tmp23_, GTK_STYLE_CLASS_INLINE_TOOLBAR);
		_tmp24_ = footer;
		_tmp25_ = indicator_label;
		gtk_action_bar_pack_start (_tmp24_, (GtkWidget*) _tmp25_);
		_tmp26_ = footer;
		_tmp27_ = indicator_switch;
		gtk_action_bar_pack_end (_tmp26_, (GtkWidget*) _tmp27_);
		_tmp28_ = (GtkGrid*) gtk_grid_new ();
		g_object_ref_sink (_tmp28_);
		sidebar = _tmp28_;
		_tmp29_ = sidebar;
		_tmp30_ = self->priv->categories;
		gtk_grid_attach (_tmp29_, (GtkWidget*) _tmp30_, 0, 0, 1, 1);
		_tmp31_ = sidebar;
		_tmp32_ = footer;
		gtk_grid_attach (_tmp31_, (GtkWidget*) _tmp32_, 0, 1, 1, 1);
		_tmp33_ = (GtkPaned*) gtk_paned_new (GTK_ORIENTATION_HORIZONTAL);
		g_object_ref_sink (_tmp33_);
		paned = _tmp33_;
		_tmp34_ = paned;
		_tmp35_ = sidebar;
		gtk_paned_pack1 (_tmp34_, (GtkWidget*) _tmp35_, FALSE, FALSE);
		_tmp36_ = paned;
		_tmp37_ = stack;
		gtk_paned_add2 (_tmp36_, (GtkWidget*) _tmp37_);
		_tmp38_ = (GtkGrid*) gtk_grid_new ();
		gtk_orientable_set_orientation ((GtkOrientable*) _tmp38_, GTK_ORIENTATION_VERTICAL);
		g_object_ref_sink (_tmp38_);
		_g_object_unref0 (self->priv->grid);
		self->priv->grid = _tmp38_;
		_tmp39_ = self->priv->grid;
		_tmp40_ = infobar;
		gtk_container_add ((GtkContainer*) _tmp39_, (GtkWidget*) _tmp40_);
		_tmp41_ = self->priv->grid;
		_tmp42_ = paned;
		gtk_container_add ((GtkContainer*) _tmp41_, (GtkWidget*) _tmp42_);
		_tmp43_ = self->priv->grid;
		gtk_widget_show_all ((GtkWidget*) _tmp43_);
		_tmp44_ = g_settings_new ("io.elementary.desktop.wingpanel.a11y");
		panel_settings = _tmp44_;
		_tmp45_ = panel_settings;
		_tmp46_ = indicator_switch;
		g_settings_bind (_tmp45_, "show-indicator", (GObject*) _tmp46_, "active", G_SETTINGS_BIND_DEFAULT);
		_g_object_unref0 (panel_settings);
		_g_object_unref0 (paned);
		_g_object_unref0 (sidebar);
		_g_object_unref0 (footer);
		_g_object_unref0 (indicator_switch);
		_g_object_unref0 (indicator_label);
		_g_object_unref0 (stack);
		_g_object_unref0 (infobar_box);
		_g_object_unref0 (infobar);
		_g_object_unref0 (info_label);
		_g_free0 (info_details);
		_g_free0 (info_title);
	}
	_tmp47_ = self->priv->grid;
	_tmp48_ = _g_object_ref0 ((GtkWidget*) _tmp47_);
	result = _tmp48_;
	return result;
}

static void
accessibility_plug_real_shown (SwitchboardPlug* base)
{
	AccessibilityPlug * self;
	self = (AccessibilityPlug*) base;
}

static void
accessibility_plug_real_hidden (SwitchboardPlug* base)
{
	AccessibilityPlug * self;
	self = (AccessibilityPlug*) base;
}

static void
accessibility_plug_real_search_callback (SwitchboardPlug* base,
                                         const gchar* location)
{
	AccessibilityPlug * self;
	const gchar* _tmp0_;
	GQuark _tmp2_ = 0U;
	static GQuark _tmp1_label0 = 0;
	static GQuark _tmp1_label1 = 0;
	static GQuark _tmp1_label2 = 0;
	static GQuark _tmp1_label3 = 0;
	self = (AccessibilityPlug*) base;
	g_return_if_fail (location != NULL);
	_tmp0_ = location;
	_tmp2_ = (NULL == _tmp0_) ? 0 : g_quark_from_string (_tmp0_);
	if (_tmp2_ == ((0 != _tmp1_label0) ? _tmp1_label0 : (_tmp1_label0 = g_quark_from_static_string ("Audio")))) {
		switch (0) {
			default:
			{
				AccessibilityCategories* _tmp3_;
				_tmp3_ = self->priv->categories;
				accessibility_categories_set_row_number (_tmp3_, 2);
				break;
			}
		}
	} else if (_tmp2_ == ((0 != _tmp1_label1) ? _tmp1_label1 : (_tmp1_label1 = g_quark_from_static_string ("Typing")))) {
		switch (0) {
			default:
			{
				AccessibilityCategories* _tmp4_;
				_tmp4_ = self->priv->categories;
				accessibility_categories_set_row_number (_tmp4_, 3);
				break;
			}
		}
	} else if (_tmp2_ == ((0 != _tmp1_label2) ? _tmp1_label2 : (_tmp1_label2 = g_quark_from_static_string ("Keyboard")))) {
		switch (0) {
			default:
			{
				AccessibilityCategories* _tmp5_;
				_tmp5_ = self->priv->categories;
				accessibility_categories_set_row_number (_tmp5_, 4);
				break;
			}
		}
	} else if (_tmp2_ == ((0 != _tmp1_label3) ? _tmp1_label3 : (_tmp1_label3 = g_quark_from_static_string ("Pointing")))) {
		switch (0) {
			default:
			{
				AccessibilityCategories* _tmp6_;
				_tmp6_ = self->priv->categories;
				accessibility_categories_set_row_number (_tmp6_, 5);
				break;
			}
		}
	} else {
		switch (0) {
			default:
			{
				AccessibilityCategories* _tmp7_;
				_tmp7_ = self->priv->categories;
				accessibility_categories_set_row_number (_tmp7_, 0);
				break;
			}
		}
	}
}

static void
accessibility_plug_real_search_data_free (gpointer _data)
{
	AccessibilityPlugSearchData* _data_;
	_data_ = _data;
	_g_free0 (_data_->search);
	_g_object_unref0 (_data_->result);
	_g_object_unref0 (_data_->self);
	g_slice_free (AccessibilityPlugSearchData, _data_);
}

static void
accessibility_plug_real_search (SwitchboardPlug* base,
                                const gchar* search,
                                GAsyncReadyCallback _callback_,
                                gpointer _user_data_)
{
	AccessibilityPlug * self;
	AccessibilityPlugSearchData* _data_;
	AccessibilityPlug* _tmp0_;
	gchar* _tmp1_;
	g_return_if_fail (search != NULL);
	self = (AccessibilityPlug*) base;
	_data_ = g_slice_new0 (AccessibilityPlugSearchData);
	_data_->_async_result = g_task_new (G_OBJECT (self), NULL, _callback_, _user_data_);
	g_task_set_task_data (_data_->_async_result, _data_, accessibility_plug_real_search_data_free);
	_tmp0_ = _g_object_ref0 (self);
	_data_->self = _tmp0_;
	_tmp1_ = g_strdup (search);
	_g_free0 (_data_->search);
	_data_->search = _tmp1_;
	accessibility_plug_real_search_co (_data_);
}

static GeeTreeMap*
accessibility_plug_search_finish (SwitchboardPlug* base,
                                  GAsyncResult* _res_)
{
	GeeTreeMap* result;
	AccessibilityPlugSearchData* _data_;
	_data_ = g_task_propagate_pointer (G_TASK (_res_), NULL);
	result = _data_->result;
	_data_->result = NULL;
	return result;
}

static gboolean
accessibility_plug_real_search_co (AccessibilityPlugSearchData* _data_)
{
	switch (_data_->_state_) {
		case 0:
		goto _state_0;
		default:
		g_assert_not_reached ();
	}
	_state_0:
	_data_->_tmp0_ = ((GCompareFunc) g_strcmp0);
	_data_->_tmp1_ = g_str_equal;
	_data_->_tmp2_ = gee_tree_map_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, (GCompareDataFunc) _data_->_tmp0_, NULL, NULL, (GeeEqualDataFunc) _data_->_tmp1_, NULL, NULL);
	_data_->search_results = _data_->_tmp2_;
	_data_->_tmp3_ = switchboard_plug_get_display_name ((SwitchboardPlug*) _data_->self);
	_data_->_tmp4_ = _data_->_tmp3_;
	_data_->_tmp5_ = g_strdup_printf ("%s → %s", _data_->_tmp4_, _ ("Accessibility Features"));
	_data_->_tmp6_ = _data_->_tmp5_;
	gee_abstract_map_set ((GeeAbstractMap*) _data_->search_results, _data_->_tmp6_, "");
	_g_free0 (_data_->_tmp6_);
	_data_->_tmp7_ = switchboard_plug_get_display_name ((SwitchboardPlug*) _data_->self);
	_data_->_tmp8_ = _data_->_tmp7_;
	_data_->_tmp9_ = g_strdup_printf ("%s → %s", _data_->_tmp8_, _ ("Audio"));
	_data_->_tmp10_ = _data_->_tmp9_;
	gee_abstract_map_set ((GeeAbstractMap*) _data_->search_results, _data_->_tmp10_, "Audio");
	_g_free0 (_data_->_tmp10_);
	_data_->_tmp11_ = switchboard_plug_get_display_name ((SwitchboardPlug*) _data_->self);
	_data_->_tmp12_ = _data_->_tmp11_;
	_data_->_tmp13_ = g_strdup_printf ("%s → %s", _data_->_tmp12_, _ ("Hearing"));
	_data_->_tmp14_ = _data_->_tmp13_;
	gee_abstract_map_set ((GeeAbstractMap*) _data_->search_results, _data_->_tmp14_, "Audio");
	_g_free0 (_data_->_tmp14_);
	_data_->_tmp15_ = switchboard_plug_get_display_name ((SwitchboardPlug*) _data_->self);
	_data_->_tmp16_ = _data_->_tmp15_;
	_data_->_tmp17_ = g_strdup_printf ("%s → %s → %s", _data_->_tmp16_, _ ("Audio"), _ ("Visual Alerts"));
	_data_->_tmp18_ = _data_->_tmp17_;
	gee_abstract_map_set ((GeeAbstractMap*) _data_->search_results, _data_->_tmp18_, "Audio");
	_g_free0 (_data_->_tmp18_);
	_data_->_tmp19_ = switchboard_plug_get_display_name ((SwitchboardPlug*) _data_->self);
	_data_->_tmp20_ = _data_->_tmp19_;
	_data_->_tmp21_ = g_strdup_printf ("%s → %s → %s", _data_->_tmp20_, _ ("Audio"), _ ("Flash screen"));
	_data_->_tmp22_ = _data_->_tmp21_;
	gee_abstract_map_set ((GeeAbstractMap*) _data_->search_results, _data_->_tmp22_, "Audio");
	_g_free0 (_data_->_tmp22_);
	_data_->_tmp23_ = switchboard_plug_get_display_name ((SwitchboardPlug*) _data_->self);
	_data_->_tmp24_ = _data_->_tmp23_;
	_data_->_tmp25_ = g_strdup_printf ("%s → %s → %s", _data_->_tmp24_, _ ("Audio"), _ ("Screen Reader"));
	_data_->_tmp26_ = _data_->_tmp25_;
	gee_abstract_map_set ((GeeAbstractMap*) _data_->search_results, _data_->_tmp26_, "Audio");
	_g_free0 (_data_->_tmp26_);
	_data_->_tmp27_ = switchboard_plug_get_display_name ((SwitchboardPlug*) _data_->self);
	_data_->_tmp28_ = _data_->_tmp27_;
	_data_->_tmp29_ = g_strdup_printf ("%s → %s → %s", _data_->_tmp28_, _ ("Audio"), _ ("Audio descriptions"));
	_data_->_tmp30_ = _data_->_tmp29_;
	gee_abstract_map_set ((GeeAbstractMap*) _data_->search_results, _data_->_tmp30_, "Audio");
	_g_free0 (_data_->_tmp30_);
	_data_->_tmp31_ = switchboard_plug_get_display_name ((SwitchboardPlug*) _data_->self);
	_data_->_tmp32_ = _data_->_tmp31_;
	_data_->_tmp33_ = g_strdup_printf ("%s → %s → %s", _data_->_tmp32_, _ ("Audio"), _ ("keyboard shortcut"));
	_data_->_tmp34_ = _data_->_tmp33_;
	gee_abstract_map_set ((GeeAbstractMap*) _data_->search_results, _data_->_tmp34_, "Audio");
	_g_free0 (_data_->_tmp34_);
	_data_->_tmp35_ = switchboard_plug_get_display_name ((SwitchboardPlug*) _data_->self);
	_data_->_tmp36_ = _data_->_tmp35_;
	_data_->_tmp37_ = g_strdup_printf ("%s → %s", _data_->_tmp36_, _ ("Typing"));
	_data_->_tmp38_ = _data_->_tmp37_;
	gee_abstract_map_set ((GeeAbstractMap*) _data_->search_results, _data_->_tmp38_, "Typing");
	_g_free0 (_data_->_tmp38_);
	_data_->_tmp39_ = switchboard_plug_get_display_name ((SwitchboardPlug*) _data_->self);
	_data_->_tmp40_ = _data_->_tmp39_;
	_data_->_tmp41_ = g_strdup_printf ("%s → %s → %s", _data_->_tmp40_, _ ("Typing"), _ ("On-screen keyboard"));
	_data_->_tmp42_ = _data_->_tmp41_;
	gee_abstract_map_set ((GeeAbstractMap*) _data_->search_results, _data_->_tmp42_, "Typing");
	_g_free0 (_data_->_tmp42_);
	_data_->_tmp43_ = switchboard_plug_get_display_name ((SwitchboardPlug*) _data_->self);
	_data_->_tmp44_ = _data_->_tmp43_;
	_data_->_tmp45_ = g_strdup_printf ("%s → %s → %s", _data_->_tmp44_, _ ("Typing"), _ ("Typing Delays"));
	_data_->_tmp46_ = _data_->_tmp45_;
	gee_abstract_map_set ((GeeAbstractMap*) _data_->search_results, _data_->_tmp46_, "Typing");
	_g_free0 (_data_->_tmp46_);
	_data_->_tmp47_ = switchboard_plug_get_display_name ((SwitchboardPlug*) _data_->self);
	_data_->_tmp48_ = _data_->_tmp47_;
	_data_->_tmp49_ = g_strdup_printf ("%s → %s → %s", _data_->_tmp48_, _ ("Typing"), _ ("Delay between key presses (slow keys)"));
	_data_->_tmp50_ = _data_->_tmp49_;
	gee_abstract_map_set ((GeeAbstractMap*) _data_->search_results, _data_->_tmp50_, "Typing");
	_g_free0 (_data_->_tmp50_);
	_data_->_tmp51_ = switchboard_plug_get_display_name ((SwitchboardPlug*) _data_->self);
	_data_->_tmp52_ = _data_->_tmp51_;
	_data_->_tmp53_ = g_strdup_printf ("%s → %s → %s", _data_->_tmp52_, _ ("Typing"), _ ("Beep when a key is pressed"));
	_data_->_tmp54_ = _data_->_tmp53_;
	gee_abstract_map_set ((GeeAbstractMap*) _data_->search_results, _data_->_tmp54_, "Typing");
	_g_free0 (_data_->_tmp54_);
	_data_->_tmp55_ = switchboard_plug_get_display_name ((SwitchboardPlug*) _data_->self);
	_data_->_tmp56_ = _data_->_tmp55_;
	_data_->_tmp57_ = g_strdup_printf ("%s → %s → %s", _data_->_tmp56_, _ ("Typing"), _ ("Beep when a key is accepted"));
	_data_->_tmp58_ = _data_->_tmp57_;
	gee_abstract_map_set ((GeeAbstractMap*) _data_->search_results, _data_->_tmp58_, "Typing");
	_g_free0 (_data_->_tmp58_);
	_data_->_tmp59_ = switchboard_plug_get_display_name ((SwitchboardPlug*) _data_->self);
	_data_->_tmp60_ = _data_->_tmp59_;
	_data_->_tmp61_ = g_strdup_printf ("%s → %s → %s", _data_->_tmp60_, _ ("Typing"), _ ("Beep when a key is rejected"));
	_data_->_tmp62_ = _data_->_tmp61_;
	gee_abstract_map_set ((GeeAbstractMap*) _data_->search_results, _data_->_tmp62_, "Typing");
	_g_free0 (_data_->_tmp62_);
	_data_->_tmp63_ = switchboard_plug_get_display_name ((SwitchboardPlug*) _data_->self);
	_data_->_tmp64_ = _data_->_tmp63_;
	_data_->_tmp65_ = g_strdup_printf ("%s → %s → %s", _data_->_tmp64_, _ ("Typing"), _ ("Typing Delay length"));
	_data_->_tmp66_ = _data_->_tmp65_;
	gee_abstract_map_set ((GeeAbstractMap*) _data_->search_results, _data_->_tmp66_, "Typing");
	_g_free0 (_data_->_tmp66_);
	_data_->_tmp67_ = switchboard_plug_get_display_name ((SwitchboardPlug*) _data_->self);
	_data_->_tmp68_ = _data_->_tmp67_;
	_data_->_tmp69_ = g_strdup_printf ("%s → %s → %s", _data_->_tmp68_, _ ("Typing"), _ ("Fast Typing"));
	_data_->_tmp70_ = _data_->_tmp69_;
	gee_abstract_map_set ((GeeAbstractMap*) _data_->search_results, _data_->_tmp70_, "Typing");
	_g_free0 (_data_->_tmp70_);
	_data_->_tmp71_ = switchboard_plug_get_display_name ((SwitchboardPlug*) _data_->self);
	_data_->_tmp72_ = _data_->_tmp71_;
	_data_->_tmp73_ = g_strdup_printf ("%s → %s → %s", _data_->_tmp72_, _ ("Typing"), _ ("Ignore fast duplicate keypresses (bounce keys)"));
	_data_->_tmp74_ = _data_->_tmp73_;
	gee_abstract_map_set ((GeeAbstractMap*) _data_->search_results, _data_->_tmp74_, "Typing");
	_g_free0 (_data_->_tmp74_);
	_data_->_tmp75_ = switchboard_plug_get_display_name ((SwitchboardPlug*) _data_->self);
	_data_->_tmp76_ = _data_->_tmp75_;
	_data_->_tmp77_ = g_strdup_printf ("%s → %s → %s", _data_->_tmp76_, _ ("Typing"), _ ("Beep when a key is rejected"));
	_data_->_tmp78_ = _data_->_tmp77_;
	gee_abstract_map_set ((GeeAbstractMap*) _data_->search_results, _data_->_tmp78_, "Typing");
	_g_free0 (_data_->_tmp78_);
	_data_->_tmp79_ = switchboard_plug_get_display_name ((SwitchboardPlug*) _data_->self);
	_data_->_tmp80_ = _data_->_tmp79_;
	_data_->_tmp81_ = g_strdup_printf ("%s → %s → %s", _data_->_tmp80_, _ ("Typing"), _ ("Fast Typing Delay length"));
	_data_->_tmp82_ = _data_->_tmp81_;
	gee_abstract_map_set ((GeeAbstractMap*) _data_->search_results, _data_->_tmp82_, "Typing");
	_g_free0 (_data_->_tmp82_);
	_data_->_tmp83_ = switchboard_plug_get_display_name ((SwitchboardPlug*) _data_->self);
	_data_->_tmp84_ = _data_->_tmp83_;
	_data_->_tmp85_ = g_strdup_printf ("%s → %s", _data_->_tmp84_, _ ("Keyboard"));
	_data_->_tmp86_ = _data_->_tmp85_;
	gee_abstract_map_set ((GeeAbstractMap*) _data_->search_results, _data_->_tmp86_, "Keyboard");
	_g_free0 (_data_->_tmp86_);
	_data_->_tmp87_ = switchboard_plug_get_display_name ((SwitchboardPlug*) _data_->self);
	_data_->_tmp88_ = _data_->_tmp87_;
	_data_->_tmp89_ = g_strdup_printf ("%s → %s → %s", _data_->_tmp88_, _ ("Keyboard"), _ ("Beep when a lock key is pressed"));
	_data_->_tmp90_ = _data_->_tmp89_;
	gee_abstract_map_set ((GeeAbstractMap*) _data_->search_results, _data_->_tmp90_, "Keyboard");
	_g_free0 (_data_->_tmp90_);
	_data_->_tmp91_ = switchboard_plug_get_display_name ((SwitchboardPlug*) _data_->self);
	_data_->_tmp92_ = _data_->_tmp91_;
	_data_->_tmp93_ = g_strdup_printf ("%s → %s → %s", _data_->_tmp92_, _ ("Keyboard"), _ ("Use modifier keys in sequence (sticky keys)"));
	_data_->_tmp94_ = _data_->_tmp93_;
	gee_abstract_map_set ((GeeAbstractMap*) _data_->search_results, _data_->_tmp94_, "Keyboard");
	_g_free0 (_data_->_tmp94_);
	_data_->_tmp95_ = switchboard_plug_get_display_name ((SwitchboardPlug*) _data_->self);
	_data_->_tmp96_ = _data_->_tmp95_;
	_data_->_tmp97_ = g_strdup_printf ("%s → %s → %s", _data_->_tmp96_, _ ("Keyboard"), _ ("Beep when a modifier key is pressed"));
	_data_->_tmp98_ = _data_->_tmp97_;
	gee_abstract_map_set ((GeeAbstractMap*) _data_->search_results, _data_->_tmp98_, "Keyboard");
	_g_free0 (_data_->_tmp98_);
	_data_->result = _data_->search_results;
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
	if (_data_->_state_ != 0) {
		while (!g_task_get_completed (_data_->_async_result)) {
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
		}
	}
	g_object_unref (_data_->_async_result);
	return FALSE;
}

static void
accessibility_plug_class_init (AccessibilityPlugClass * klass,
                               gpointer klass_data)
{
	GSettings* _tmp0_;
	GSettings* _tmp1_;
	accessibility_plug_parent_class = g_type_class_peek_parent (klass);
	g_type_class_adjust_private_offset (klass, &AccessibilityPlug_private_offset);
	((SwitchboardPlugClass *) klass)->get_widget = (GtkWidget* (*) (SwitchboardPlug*)) accessibility_plug_real_get_widget;
	((SwitchboardPlugClass *) klass)->shown = (void (*) (SwitchboardPlug*)) accessibility_plug_real_shown;
	((SwitchboardPlugClass *) klass)->hidden = (void (*) (SwitchboardPlug*)) accessibility_plug_real_hidden;
	((SwitchboardPlugClass *) klass)->search_callback = (void (*) (SwitchboardPlug*, const gchar*)) accessibility_plug_real_search_callback;
	((SwitchboardPlugClass *) klass)->search = (void (*) (SwitchboardPlug*, const gchar*, GAsyncReadyCallback, gpointer)) accessibility_plug_real_search;
	((SwitchboardPlugClass *) klass)->search_finish = (GeeTreeMap* (*) (SwitchboardPlug*, GAsyncResult*)) accessibility_plug_search_finish;
	G_OBJECT_CLASS (klass)->finalize = accessibility_plug_finalize;
	_tmp0_ = g_settings_new ("org.gnome.desktop.a11y.applications");
	_g_object_unref0 (accessibility_plug_applications_settings);
	accessibility_plug_applications_settings = _tmp0_;
	_tmp1_ = g_settings_new ("org.gnome.desktop.a11y.keyboard");
	_g_object_unref0 (accessibility_plug_keyboard_settings);
	accessibility_plug_keyboard_settings = _tmp1_;
}

static void
accessibility_plug_instance_init (AccessibilityPlug * self,
                                  gpointer klass)
{
	self->priv = accessibility_plug_get_instance_private (self);
}

static void
accessibility_plug_finalize (GObject * obj)
{
	AccessibilityPlug * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, ACCESSIBILITY_TYPE_PLUG, AccessibilityPlug);
	_g_object_unref0 (self->priv->grid);
	_g_object_unref0 (self->priv->categories);
	G_OBJECT_CLASS (accessibility_plug_parent_class)->finalize (obj);
}

static GType
accessibility_plug_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (AccessibilityPlugClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) accessibility_plug_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (AccessibilityPlug), 0, (GInstanceInitFunc) accessibility_plug_instance_init, NULL };
	GType accessibility_plug_type_id;
	accessibility_plug_type_id = g_type_register_static (SWITCHBOARD_TYPE_PLUG, "AccessibilityPlug", &g_define_type_info, 0);
	AccessibilityPlug_private_offset = g_type_add_instance_private (accessibility_plug_type_id, sizeof (AccessibilityPlugPrivate));
	return accessibility_plug_type_id;
}

GType
accessibility_plug_get_type (void)
{
	static volatile gsize accessibility_plug_type_id__once = 0;
	if (g_once_init_enter (&accessibility_plug_type_id__once)) {
		GType accessibility_plug_type_id;
		accessibility_plug_type_id = accessibility_plug_get_type_once ();
		g_once_init_leave (&accessibility_plug_type_id__once, accessibility_plug_type_id);
	}
	return accessibility_plug_type_id__once;
}

SwitchboardPlug*
get_plug (GModule* module)
{
	AccessibilityPlug* plug = NULL;
	AccessibilityPlug* _tmp0_;
	SwitchboardPlug* result;
	g_return_val_if_fail (module != NULL, NULL);
	g_debug ("Plug.vala:168: Activating Accessibility plug");
	_tmp0_ = accessibility_plug_new ();
	plug = _tmp0_;
	result = (SwitchboardPlug*) plug;
	return result;
}

